;uses tutunit,crt;

; const cube: Array(0..23( of real = {good old cube}
;        (-1,-1,-1,-1,-1,1,-1,1,-1,
;         -1,1,1,1,-1,-1,1,-1,1,
;         1,1,-1,1,1,1);
;     pindex: Array(0..23( of byte = {plane index: 4 points = 1 plane}
;      (0,3,1,2,0,5,4,1,0,6,2,4,6,3,2,7,3,5,1,7,4,7,6,5);
Global Dim cube.f(23)
Global Dim cube2.f(23)

Global Dim pindex.b(23)
Global Dim testp.POINT(10)
Global x0=320
Global y0=240

Global ax=5
Global ay=2
Global az=3

; Global    cos002.f= 9.9980000666E-01; {precalculated values of cos/sin}
; Global    sin002.f= 1.9998666693E-02; {...it's a bit faster...}
; Global    cos005.f= 9.9875026039E-01;
; Global    sin005.f= 4.9979169271E-02;
; Global    cos010.f= 9.9500416528E-01;
; Global    sin010.f= 9.9833416647E-02;
;var xt,yt,zt:real;
;Global  xt.f,yt.f,zt.f
;    p,pp,zoom,per,q1,q2,q3,q:integer;
Global p.l,pp.l,zoom.l,per.l,q1.l,q2.l,q3.l,q.l
;Global pom.f,v1.f,v2.f,v3.f,u1.f,u2.f,u3.f,n1.f,n2.f,n3.f,n.f
;     r,g,b:byte;
;     uncube: Array(0..23( of real;

Procedure draw()
  
    DC.l=StartDrawing(ScreenOutput())
    Box(0,0,640,480,0)

    For p=0 To 5 ;{...For all 6 planes of the cube}
      
x1.f=cube(pindex(p*4)*3)
y1.f=cube(pindex(p*4)*3+1)
z1.f=cube(pindex(p*4)*3+2)
x3.f=cube(pindex(p*4+1)*3)
y3.f=cube(pindex(p*4+1)*3+1)
z3.f=cube(pindex(p*4+1)*3+2)
x2.f=cube(pindex(p*4+2)*3)
y2.f=cube(pindex(p*4+2)*3+1)
z2.f=cube(pindex(p*4+2)*3+2)
x4.f=cube(pindex(p*4+3)*3)
y4.f=cube(pindex(p*4+3)*3+1)
z4.f=cube(pindex(p*4+3)*3+2)

  v1.f=x1-x3;cube(pindex(p*4)*3)-cube(pindex(p*4+1)*3);      {vector1_coord1}
  v2.f=y1-y3;cube(pindex(p*4)*3+1)-cube(pindex(p*4+1)*3+1);  {vector1_coord2}
  v3.f=z1-z3;cube(pindex(p*4)*3+2)-cube(pindex(p*4+1)*3+2);  {...}
  u1.f=x2-x1;x2-x4;cube(pindex(p*4+2)*3)-cube(pindex(p*4+3)*3);    {vector2_coord1}
  u2.f=y2-y1;y2-y4;cube(pindex(p*4+2)*3+1)-cube(pindex(p*4+3)*3+1); {...}
  u3.f=z2-z1;z2-z4;cube(pindex(p*4+2)*3+2)-cube(pindex(p*4+3)*3+2);
  n1.f=v2*u3-u2*v3; {normal_coord1}
  n2.f=v3*u1-u3*v1; {...}
  n3.f=v1*u2-u1*v2;
  n.f=Sqr(n1*n1+n2*n2+n3*n3); {size of the normal}
  pom.f=(n3*q3)/(n*q); {(cos of the) angle between the normal and the viewpoint}
  If pom>0;{If the (cos)angle is lower than zero, don't show}
      testp(0)\x=Int(zoom*x1+x0)
      testp(0)\y=Int(zoom*y1+y0)
      testp(1)\x=Int(zoom*x2+x0)
      testp(1)\y=Int(zoom*y2+y0)
      testp(2)\x=Int(zoom*x3+x0)
      testp(2)\y=Int(zoom*y3+y0)
      testp(3)\x=Int(zoom*x4+x0)
      testp(3)\y=Int(zoom*y4+y0)

res.a=Int(pom*255)
colo.l=RGB(res,res,res)
;     LineXY(x1,y1,x2,y2,colo)
;     LineXY(x2,y2,x3,y3,colo)
;      LineXY(x3,y3,x4,y4,colo)
;      LineXY(x4,y4,x1,y1,colo)
  hb.l=CreateSolidBrush_(colo)
  hp.l=CreatePen_(#PS_SOLID,1,colo);$FFFFFF*0)
  SelectObject_(DC,hb)
  SelectObject_(DC,hp)
  Polygon_(DC,@testp(),4)
  DeleteObject_(hb)
  DeleteObject_(hp)
   EndIf
 Next p; End;
   StopDrawing() 
  FlipBuffers() 
EndProcedure

Procedure rotate()
  c.f=#PI/180
 For p=0 To 7
 ; Yt = cube(p*3+1) * COS002 - cube(p*3+2) * SIN002;
 ;Zt = cube(p*3+1) * SIN002 + cube(p*3+2) * COS002;
  x.f=cube2(p*3)
  y.f=cube2(p*3+1)
  z.f=cube2(p*3+2)
  yt.f = Cos (ax*c)*y - Sin (ax*c)*z
  zt.f = Sin (ax*c)*y + Cos (ax*c)*z

  cube(p*3+1) = Yt;
  cube(p*3+2) = Zt;
  
  ;x.f=cube2(p*3)
  y.f=yt;cube2(p*3+1)
  z.f=zt;cube2(p*3+2)

;  Xt = cube(p*3) * COS005 - cube(p*3+2) * SIN005;
;  Zt = cube(p*3) * SIN005 + cube(p*3+2) * COS005;
  Xt.f = Cos (ay*c)*x - Sin (ay*c)*z
  Zt.f = Sin (ay*c)*x + Cos (ay*c)*z

  cube(p*3) = Xt;
  cube(p*3+2) = Zt;
  
  x.f=xt;cube2(p*3)
  y.f=yt;cube2(p*3+1)
  z.f=zt;cube2(p*3+2)

  ;Xt = cube(p*3) * COS010 - cube(p*3+1) * SIN010;
  ;Yt = cube(p*3) * SIN010 + cube(p*3+1) * COS010;
  xt.f = Cos (az*c)*x - Sin (az*c)*y
  yt.f = Sin (az*c)*x + Cos (az*c)*y
  
  cube(p*3) = Xt;
  cube(p*3+1) = Yt;
Next p
   ax=(ax+2)%360
   ay=(ay+1)%360
   az=(az+3)%360

EndProcedure

; Procedure rotate()
;  For p=0 To 7
;   Yt.f = cube(p*3+1) * COS002 - cube(p*3+2) * SIN002;
;   Zt.f = cube(p*3+1) * SIN002 + cube(p*3+2) * COS002;
;   cube(p*3+1) = Yt;
;   cube(p*3+2) = Zt;
; 
;   Xt.f = cube(p*3) * COS005 - cube(p*3+2) * SIN005;
;   Zt.f = cube(p*3) * SIN005 + cube(p*3+2) * COS005;
;   cube(p*3) = Xt;
;   cube(p*3+2) = Zt;
; 
;   Xt.f = cube(p*3) * COS010 - cube(p*3+1) * SIN010;
;   Yt.f = cube(p*3) * SIN010 + cube(p*3+1) * COS010;
;   cube(p*3) = Xt;
;   cube(p*3+1) = Yt;
;  Next p
; EndProcedure

; setmode;
;  r=60; {color_red}
;  g=60; {..._green}
;  b=0;  {..._blue}
 q1=0; {viewpoint/lightsource_coord1 - its precalculated - it doesnt change}
 q2=0; {..._coord2}
 q3=-4; {...}
; q=4; {size of the viewpoint}
q=Sqr(q1*q1+q2*q2+q3*q3) 
; per=6; {perspective}
 zoom=90; {size}
 
 Restore cube_
 For i=0 To 23
   Read.b cube(i)
   cube(i);*90
   cube2(i)=cube(i)
 Next i
 
  Restore pindex_
 For i=0 To 23
   Read.b pindex(i)
 Next i

 If InitSprite() And OpenWindow(0,0,0,640,480,"Cube",#PB_Window_SystemMenu|#PB_Window_MinimizeGadget) And OpenWindowedScreen(WindowID(0),0,0,640,480,0,0,0)

 draw(); {draws...}
 Repeat; {...loops...}
  rotate(); {...calculates new values...}
  ;undraw; {...and undraws...}
  draw(); {...and draws again...}
;  writeln('Made by fh(C)96.');
    If GetAsyncKeyState_(#VK_ESCAPE)&$8000
    Break
  EndIf

  Until WindowEvent()=#PB_Event_CloseWindow 
EndIf

DataSection:
cube_:
Data.b  -1,-1,-1,-1,-1,1,-1,1,-1,-1,1,1,1,-1,-1,1,-1,1,1,1,-1,1,1,1
pindex_:
Data.b 0,3,1,2,0,5,4,1,0,6,2,4,6,3,2,7,3,5,1,7,4,7,6,5

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 172
; FirstLine = 159
; Folding = -
; EnableUnicode
; EnableXP
; Executable = flats.exe